/*  Authentication headers

    1998, 1999 Joseph Walton

    This software is distributed under the terms of the GNU General Public
    License; either version 2 of the License, or (at your option) any
    later version.
*/

#ifndef NFSD_AUTH_H
#define NFSD_AUTH_H

#include "nfs.h"
#include <exec/types.h>

/* Permissions we may wish to give, or check for*/
#define ALLOW_READ 1     /* They can read arbitrary data from it */
#define ALLOW_WRITE 2    /* They can write arbitrary data to it */
#define ALLOW_SETATTRS 3 /* They may set attributes of this file */
#define ALLOW_GETATTRS 4 /* They may get the attributes of this file */

/* Public prototypes */

nfsstat check_permission(struct Call *call, struct LocalFile *lf,
    ULONG permission);
nfsstat does_mount_permit(struct Call *call,
    STRPTR path, ULONG permission);
nfsstat does_file_allow(struct Call *call, UWORD uid, UWORD gid,
    LONG prot, ULONG permission);
LONG owner_of(struct Call *call);
void print_auth(struct Call *call);
void print_auth_once(struct Call *call);
void impose_configuration(struct LocalFile *lf);

#endif

