/*  Configuration file headers

    1998 Joseph Walton

    This software is distributed under the terms of the GNU General Public
    License; either version 2 of the License, or (at your option) any
    later version.
*/

#ifndef NFSD_CONFIG_H
#define NFSD_CONFIG_H

#include <exec/nodes.h>

struct ConfigEntry {
    struct MinNode ce_Node;
    STRPTR ce_Path;
    STRPTR ce_ExportAs;
    ULONG ce_ExportIP;
    ULONG ce_IPMask;
    BOOL ce_ReadWrite;

    /* Extra fields added 9th April 1999.
        They're signed, and -1 means "unset" */
    LONG ce_UID;
    LONG ce_GID;
    LONG ce_Protection;
    BOOL ce_ForceAll; /* Should all entries have these values, or just the mountpoint? */
};

/* Public prototypes */
BOOL process_cfg(STRPTR cfg_name);

#endif

