/*  Headers for the directory scanning routines

    1998 Joseph Walton

    This software is distributed under the terms of the GNU General Public
    License; either version 2 of the License, or (at your option) any
    later version.
*/

#ifndef NFSD_DIRLIST_H
#define NFSD_DIRLIST_H

#include "nfs.h"

#include <exec/nodes.h>
#include <exec/lists.h>
#include <dos/dos.h>

struct DEList {
    struct MinList del_List;
    struct DateStamp del_DateStamp; /* When was this list built? */
};

struct DirEntry {
    struct MinNode de_Node;
    int de_NameChars;   /* Number of characters in the name */
    int de_NameInt32s;  /* Number of int32s in the name */
    int32 *de_Name;     /* int32-aligned, zero-padded block of memory */
    u_int  de_Inode;
};

/* Public prototypes */
void free_delist_nodes(struct DEList *del);
int readdir(struct LocalFile *dir_lf, int32 *rptr, int32 *rlimit, u_int cookie,
    u_int max_count);

#endif

