/*  Headers for NFS functions

    1998, 1999 Joseph Walton

    This software is distributed under the terms of the GNU General Public
    License; either version 2 of the License, or (at your option) any
    later version.
*/

#ifndef NFSD_NFS_FUNCTIONS_H
#define NFSD_NFS_FUNCTIONS_H

#include "nfs.h"

int nfsproc_getattr_2_svc(nfs_fh *handle, struct Call *call, int32 *rptr);
int nfsproc_setattr_2_svc(struct sattrargs *args, struct Call *call, int32 *rptr);
int nfsproc_lookup_2_svc(struct diropargs *argp, struct Call *call, int32 *rptr);
int nfsproc_read_2_svc(struct readargs *argp, struct Call *call, int32 *rptr,
    int32 *rlimit);
int nfsproc_write_2_svc(struct writeargs *argp, struct Call *call, int32 *rptr);
int nfsproc_create_2_svc(struct createargs *argp, struct Call *call, int32 *rptr);
nfsstat nfsproc_remove_2_svc(struct diropargs *argp, struct Call *call);
nfsstat nfsproc_rmdir_2_svc(struct diropargs *argp, struct Call *call);
nfsstat nfsproc_rename_2_svc(struct renameargs *argp, struct Call *call);
int nfsproc_mkdir_2_svc(struct createargs *argp, struct Call *call, int32 *rptr);
int nfsproc_readdir(struct readdirargs *args, struct Call *call,
    int32 *rptr, int32 *rlimit);
int nfsproc_statfs_2_svc(nfs_fh *handle, struct Call *call, int32 *rptr);

#endif

